//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Made by Sprinkles

::PrecacheParticle <- function(name)
{
    PrecacheEntityFromTable({ classname = "info_particle_system", effect_name = name })
}

function Precache()
{
	PrecacheParticle("cr_plr_mark_ico")
	PrecacheParticle("cr_plr_mark_ico_scout")
	PrecacheParticle("cr_plr_mark_ico_sniper")
	PrecacheParticle("cr_plr_mark_ico_soldier")
	PrecacheParticle("cr_plr_mark_ico_pyro")
	PrecacheParticle("cr_plr_mark_ico_medic")
	PrecacheParticle("cr_plr_mark_ico_engie")
	PrecacheParticle("cr_plr_mark_ico_heavy")
	PrecacheParticle("cr_plr_mark_ico_demo")
}

::PlayerPropGlowArray <-
[
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
	null,
]

//-----------------------------------------------------------------------------
// Purpose: Set a the glow ent for just one player input handle/entity , bool
//
//
//-----------------------------------------------------------------------------


::SetGlowAll <- function()
{
    for (local i = 1; i <= MaxPlayers ; i++)
    {
        local m_hPlayer = PlayerInstanceFromIndex(i)
        if (m_hPlayer != null)
        {
            PlayerPropGlowArray[m_hPlayer.entindex() - 1].AcceptInput("start", "", null, null)
        }
    }
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////
    OnGameEvent_post_inventory_application = function(params)
    {
        local m_hPlayer = GetPlayerFromUserID(params.userid)
		if (!m_hPlayer)
			return

        if (PlayerPropGlowArray[m_hPlayer.entindex() - 1] == null)
        {
            local effectname = "cr_plr_mark_ico_scout"

            switch (m_hPlayer.GetPlayerClass()) {
				case 1:
					effectname = "cr_plr_mark_ico_scout"
					break;
				case 2:
					effectname = "cr_plr_mark_ico_sniper"
					break;
				case 3:
					effectname = "cr_plr_mark_ico_soldier"
					break;
				case 4:
					effectname = "cr_plr_mark_ico_demo"
					break;
				case 5:
					effectname = "cr_plr_mark_ico_medic"
					break;
				case 6:
					effectname = "cr_plr_mark_ico_heavy"
					break;
				case 7:
					effectname = "cr_plr_mark_ico_pyro"
					break;
				case 8:
					effectname = "cr_plr_mark_ico_spy"
					break;
				case 9:
					effectname = "cr_plr_mark_ico_engie"
					break;
				default:
					effectname = "cr_plr_mark_ico_scout"
					break;
			}

            PlayerPropGlowArray[m_hPlayer.entindex() - 1] = SpawnEntityFromTable("info_particle_system", {
				start_active = 0,
				effect_name = effectname,
				origin = m_hPlayer.GetOrigin(),
			})

			NetProps.SetPropEntity(PlayerPropGlowArray[m_hPlayer.entindex() - 1], "m_hOwnerEntity", m_hPlayer)

			EntFireByHandle(PlayerPropGlowArray[m_hPlayer.entindex() - 1], "SetParent", "!activator", 0, m_hPlayer, m_hPlayer);


        }
        else if(PlayerPropGlowArray[m_hPlayer.entindex() - 1] != null)
        {
            return
        }
        else
        {
            error("this should not have happened tell sprinkles or a better programmer!")
            return
        }

    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)
