//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Orignial by Lacry
// Remade by sprinkles


IncludeScript("copsandrobbers/util/util.nut")

//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

::m_aRedPlayers <- [];
::m_aCellA <- [];
::m_aCellB <- [];
::m_iPrisoners <- 0;
::m_iPrisonersCellA <- 0;
::m_iPrisonersCellB <- 0;
::m_hEscrots <- null;

::m_bRoundActive <- false;

::m_bLastManActive <- false;
::m_hLastMan <- false;

::m_bDevMode <- IsInDebugMode();

::m_aLastManLines <- [
	"Announcer.AM_LastManAlive01",
	"Announcer.AM_LastManAlive02",
	"Announcer.AM_LastManAlive03",
	"Announcer.AM_LastManAlive04"
];

//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Purpose: Think function that counts player and handles the lastman mechanic
//-----------------------------------------------------------------------------
function count_players()
{
	if (!m_bRoundActive)
	{
		m_iPrisoners = m_aRedPlayers.len();
		m_iPrisonersCellA = m_aCellA.len();
		m_iPrisonersCellB = m_aCellB.len();
		return -1;
	}
	else
	{
		// these must be at the top to always have the latest amount of players in each array
		// put anything that doesn't require the latest value above this
		m_iPrisoners = m_aRedPlayers.len();
		m_iPrisonersCellA = m_aCellA.len();
		m_iPrisonersCellB = m_aCellB.len();


		if (m_iPrisoners == 0)
		{
			winner_logic();
		}
		else if (m_iPrisoners == 1)
		{
			if(!m_bLastManActive)
			{
				m_hLastMan = m_aRedPlayers[0];

				m_hLastMan.AddCond(16)
				m_hLastMan.AddCond(26)
				m_hLastMan.AddCond(29)
				DoEntFire("gamerules", "PlayVORed", m_aLastManLines[RandomInt(0, 3)], 0, null, null);
				printl("player " + m_hLastMan.GetPlayerName() + " is the last man!");
				m_bLastManActive = true;
			}
		}
		else if(m_iPrisoners >= 1)
		{
			if(m_bLastManActive)
			{
				m_hLastMan.RemoveCond(16)
				m_hLastMan.RemoveCond(26)
				m_hLastMan.RemoveCond(29)
				printl("player " + m_hLastMan.GetPlayerName() + " has lost the last man bonus!");
				m_bLastManActive = false;
				m_hLastMan = null;
			}
		}

		NetProps.SetPropInt(self, "m_nRedScore", m_iPrisoners);
		NetProps.SetPropInt(self, "m_nBlueScore", m_iPrisonersCellA);
		NetProps.SetPropInt(self, "m_nMaxPoints", m_iPrisonersCellB);

		return -1;
	}

	return -1;
}

//-----------------------------------------------------------------------------
// Purpose: opening of cell logic, give player the halloween overheal effect
// the person who opens the cell gets score and gets ownership of the effect
//-----------------------------------------------------------------------------
function OpenCellLogic(cell)
{
	local m_hCellOpener = activator;

	if (cell == 0)
	{
		m_hCellOpener.ScorePoints(m_iPrisonersCellA);
	}
	else if (cell == 1)
	{
		m_hCellOpener.ScorePoints(m_iPrisonersCellB);
	}
	else
	{
		DebugError("Out of range! do a value less then 1!");
	}

	for (local i = 1; i <= m_iMaxPlayers; i++)
	{
		local m_hPlayer = PlayerInstanceFromIndex(i);

		if (m_hPlayer != null)
		{
			if (cell == 0)
			{
				local index = m_aCellA.find(m_hPlayer);
				if (index != null)
				{
					m_aCellA.remove(index);
					m_aRedPlayers.append(m_hPlayer);
					m_hPlayer.RemoveCond(14);
					m_hPlayer.RemoveCond(15);
					m_hPlayer.SetForcedTauntCam(0);
					m_hPlayer.AddCondEx(51, 2, m_hCellOpener);
					m_hPlayer.AddCondEx(52, 2, m_hCellOpener);
					m_hPlayer.AddCondEx(73, 5, m_hCellOpener);
					m_hPlayer.AddCondEx(130, 2, m_hCellOpener);
					NetProps.SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 0);
					DebugPrintl(m_hPlayer.GetPlayerName() + " free from cell_red_A");
				}
			}
			else if (cell == 1)
			{
				local index = m_aCellB.find(m_hPlayer);;
				if (index != null)
				{
					m_aCellB.remove(index);
					m_aRedPlayers.append(m_hPlayer);
					m_hPlayer.RemoveCond(14);
					m_hPlayer.RemoveCond(15);
					m_hPlayer.SetForcedTauntCam(0);
					m_hPlayer.AddCondEx(51, 2, m_hCellOpener);
					m_hPlayer.AddCondEx(52, 2, m_hCellOpener);
					m_hPlayer.AddCondEx(73, 5, m_hCellOpener);
					m_hPlayer.AddCondEx(130, 2, m_hCellOpener);
					NetProps.SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 0);
					DebugPrintl(m_hPlayer.GetPlayerName() + " free from cell_red_B");
				}
			}
			else
			{
				DebugError("Out of range! do a value less then 1!");
			}
		}
	}
}

// Sets Winner/Loser (By killing)
function winner_logic()
{
	if (m_bRoundActive)
	{
		DoEntFire("game_win_blue", "RoundWin", "", 0, null, null);
	}

	return;
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////
    OnGameEvent_player_spawn = function(events)
    {
        local m_hPlayer = GetPlayerFromUserID(events.userid);
		if (!m_hPlayer)
			return;

		if (m_hPlayer.GetTeam() == TF_TEAM_BLUE)
			return;

		if (m_hPlayer.GetTeam() == 0)
			return;

		if(!m_bRoundActive)
		{
			local index = m_aRedPlayers.find(m_hPlayer);
			if (index == null)
			{
				DebugPrintl( "OnGameEvent_player_spawn player " + m_hPlayer.GetPlayerName() + " has been added to the red team array they are on the " + m_hPlayer.GetTeam() + " team");
				m_aRedPlayers.append(m_hPlayer);
			}
		}
		else
		{
			local m_hCellRespawntrigger = Entities.FindByClassnameNearest("func_respawnroom", m_hPlayer.GetOrigin(), 500.0);

			DebugPrintl(m_hCellRespawntrigger);

			if(m_hCellRespawntrigger)
			{
				local m_sCellName = m_hCellRespawntrigger.GetName();

				if (m_sCellName == "cell_red_B")
				{
					local index = m_aRedPlayers.find(m_hPlayer);
					local index2 = m_aCellA.find(m_hPlayer);
					local index3 = m_aCellB.find(m_hPlayer);

					if (index3 == null)
					{
						if (index != null)
						{
							m_aRedPlayers.remove(index);
							m_aCellB.append(m_hPlayer);
							DebugPrintl("cell_red_B");
						}
						else if(index2 != null)
						{
							m_aCellA.remove(index2);
							m_aCellB.append(m_hPlayer);
							DebugPrintl("cell_red_B");
						}
						else
						{
							m_aCellB.append(m_hPlayer);
							DebugPrintl("cell_red_B");
						}
					}
					m_hPlayer.AddCond(14);
					m_hPlayer.AddCond(15);
					m_hPlayer.SetForcedTauntCam(1);
					NetProps.SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 256 + 64);
				}
				else
				{
					local index = m_aRedPlayers.find(m_hPlayer);
					local index2 = m_aCellA.find(m_hPlayer);
					local index3 = m_aCellB.find(m_hPlayer);
					if (index2 == null)
					{
						if (index != null)
						{
							m_aRedPlayers.remove(index);
							m_aCellA.append(m_hPlayer);
							DebugPrintl("cell_red_A");
						}
						else if(index3 != null)
						{
							m_aCellB.remove(index3);
							m_aCellA.append(m_hPlayer);
							DebugPrintl("cell_red_B");
						}
						else
						{
							m_aCellA.append(m_hPlayer);
							DebugPrintl("cell_red_A");
						}
					}
					m_hPlayer.AddCond(14);
					m_hPlayer.AddCond(15);
					m_hPlayer.SetForcedTauntCam(1);
					NetProps.SetPropInt(m_hPlayer, "m_Shared.m_iStunFlags", 256 + 64);
				}
			}
		}
    }

    OnGameEvent_post_inventory_application = function(events)
    {
        local m_hPlayer = GetPlayerFromUserID(events.userid);
		if (!m_hPlayer)
			return;

    }

	OnGameEvent_player_death = function(events)
    {
        local m_hPlayer = GetPlayerFromUserID(events.userid);
		if (!m_hPlayer)
			return;

		if (m_hPlayer.GetTeam() == TF_TEAM_BLUE)
			return;

		if (m_bRoundActive == true)
		{
			local index = m_aRedPlayers.find(m_hPlayer);
			if (index != null)
			{
				m_aRedPlayers.remove(index);
				DebugPrintl("red player Removed")
			}
		}
    }

    OnGameEvent_player_team = function(events)
    {
        local m_hPlayer = GetPlayerFromUserID(events.userid);
		if (!m_hPlayer)
			return;

		local m_iOldteam = events.oldteam;
		local m_iNewteam = events.team;
		if (m_iOldteam != 0)
		{
			DebugPrintl( "OnGameEvent_player_team player" + m_hPlayer.GetPlayerName() + "has been added to the red team array they are on the " + m_hPlayer.GetTeam() + "team");
			if (m_iOldteam == TF_TEAM_BLUE)
			{
				local index = m_aRedPlayers.find(m_hPlayer);
				if (index == null)
				{
					m_aRedPlayers.append(m_hPlayer);
				}
			}
			else if(m_iOldteam == TF_TEAM_RED)
			{
				local index = m_aRedPlayers.find(m_hPlayer);
				local index2 = m_aCellA.find(m_hPlayer);
				local index3 = m_aCellB.find(m_hPlayer);
				if (index != null)
				{
					m_aRedPlayers.remove(index);
				}
				else if(index2 != null)
				{
					m_aCellA.remove(index2);
				}
				else if(index3 != null)
				{
					m_aCellB.remove(index3);
				}
			}
		}
		else
		{
			if (m_iNewteam == TF_TEAM_RED)
			{
				local index = m_aRedPlayers.find(m_hPlayer);
				if (index == null)
				{
					m_aRedPlayers.append(m_hPlayer);
				}
			}
		}


		//DebugPrintl(events.team);
		//DebugPrintl(events.oldteam);
    }

    OnGameEvent_teamplay_setup_finished = function(events)
    {
		m_bRoundActive = true;
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)
