//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Orignial by sprinkles


//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

::TF_TEAM_RED <- 2;
::TF_TEAM_BLUE <- 3;
::m_iMaxPlayers <- MaxClients().tointeger();

//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Purpose: Check the dev level
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::IsInDebugMode <- function()
{
	return GetDeveloperLevel() > 0
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugPrint <- function(pMsg)
{
	if(IsInDebugMode())
    {
        print(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugPrintl <- function(pMsg)
{
	if(IsInDebugMode())
    {
        printl(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Check the dev level and print text based on it
// input  : pMsg.
// Output : Returns true on success, false on failure.
//-----------------------------------------------------------------------------
::DebugError <- function(pMsg)
{
	if(IsInDebugMode())
    {
        error(pMsg)
    }
}

//-----------------------------------------------------------------------------
// Purpose: Adds or remove score based on events
// input  : m_iScore.
//-----------------------------------------------------------------------------
::CTFPlayer.ScorePoints <- function(m_iScore)
{
	local player = this;
	local is_bot = player.IsFakeClient()
    if (!is_bot) player.AddFlag(Constants.FPlayer.FL_FAKECLIENT)

    SendGlobalGameEvent("player_escort_score",
    {
        player = player.entindex(),
        points = m_iScore
    })

    if (!is_bot) player.RemoveFlag(Constants.FPlayer.FL_FAKECLIENT)
}

::CTFBot.ScorePoints <- CTFPlayer.ScorePoints

::CTFPlayer.GetPlayerName <- function()
{
	local player = this;
    return NetProps.GetPropString(player, "m_szNetname");
}

::CTFBot.GetPlayerName <- CTFPlayer.GetPlayerName