//-----------------------------------------------------------------------------
// Credits
//-----------------------------------------------------------------------------
// Made by Lacry


//-----------------------------------------------------------------------------
// Variables
//-----------------------------------------------------------------------------

red_players <- []
red_players_left <- 0

blue_players <- []
blue_players_left <- 0

is_round_active <- false

max_players <- MaxClients().tointeger()


//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------

ClearGameEventCallbacks()

// Counts the players during the match
function count_players()
{
	if (!is_round_active) return -1
	
	if (red_players_left == 0 || blue_players_left == 0)
	{
		winner_logic()
	}
	
	NetProps.SetPropInt(self, "m_nRedScore", red_players_left)
	NetProps.SetPropInt(self, "m_nBlueScore", blue_players_left)
	
	return -1
}


// Logic when the round starts
function round_start()
{
	for (local i = 1; i <= max_players; i++)
	{
		local player = PlayerInstanceFromIndex(i)
		if (player == null || !is_player_valid(player)) continue
		
		if (player.GetTeam() == 2)
		{
			red_players.append(player)
		}
		
		else if (player.GetTeam() == 3)
		{
			blue_players.append(player)
		}
	}
	
	is_round_active = true
	
	return
}

function is_player_valid(player)
{
	return ((player.GetTeam() & 2))
}


// RED Player Counter
function add_red()
{
	red_players_left++
}

function rest_red()
{
	red_players_left--
}


// BLU Player Counter
function add_blue()
{
	blue_players_left++
}

function rest_blue()
{
	blue_players_left--
}


// Logic when the round ends
function round_end()
{
	is_round_active = false
}


// Sets Winner/Loser (By killing)
function winner_logic()
{
	if (is_round_active == true && blue_players_left < red_players_left)
	{
		DoEntFire("game_win_red", "RoundWin", "", 0, null, null);
	}
	
	else if (is_round_active == true && blue_players_left > red_players_left)
	{
		DoEntFire("game_win_blue", "RoundWin", "", 0, null, null);
	}
	
	return
}


// Sets Winner/Loser (By timer)
function winner_timer()
{
	if (blue_players_left < red_players_left)
	{
		DoEntFire("game_win_red", "RoundWin", "", 0, null, null);
	}
	
	else if (blue_players_left > red_players_left)
	{
		DoEntFire("game_win_blue", "RoundWin", "", 0, null, null);
	}
	
	else if (blue_players_left == red_players_left)
	{
		DoEntFire("game_win_none", "RoundWin", "", 0, null, null);
	}
	
	return
}


__CollectGameEventCallbacks(this)